#ifndef mark
#define mark

/* assigns a default value to a variable if its NIL */
#command DEFAULT <p> TO <val> [,<pn> TO <valn>];
         => ;
         <p> = iif(<p> = NIL, <val>, <p>);
         [;<pn> = iif(<pn> = NIL, <valn>, <pn>)]

#xtranslate CursorOff() => SETCURSOR(0)
#xtranslate CursorOn()  => SETCURSOR(1)
         
///////////////////////////////////////////////////////////////////////
// Description : Function which returns a string indicating the      //
//               current cursor position, this string can be passed  //               
//               to REST_CURS_POS to restore the cursor position     //
///////////////////////////////////////////////////////////////////////
#xtranslate SaveCursorPos() => {Row(), Col()}

///////////////////////////////////////////////////////////////////////
// Description : Function which receives a string, created from      //               
//               SAVE_CURS_POS and restores the cursor to its prior  //
//               position.                                           //
///////////////////////////////////////////////////////////////////////
#xtranslate RestCursorPos(<anPos>) => SetPos(<anPos>\[1], <anPos>\[2])


///////////////////////////////////////////////////////////////////////
// Description : THIS WILL SAVE A SCREEN THAT WILL BE RESTORED WITH  //
//               PUTSCREEN                                           //
//                                                                   //
///////////////////////////////////////////////////////////////////////
#xtranslate GetScreen(<nTR>, <nTC>, <nBR>, <nBC>) => ;
            {<nTR>, <nTC>, <nBR>, <nBC>, SaveScreen(<nTR>, <nTC>, <nBR>, <nBC>)}

///////////////////////////////////////////////////////////////////////
// Description :  THIS WILL SAVE A SCREEN WHICH CAN BE RESTORED WITH //
//                PUTSCREEN                                          //
///////////////////////////////////////////////////////////////////////
#xtranslate PutScreen(<aScreen>) => ;
            RestScreen(<aScreen>\[1], <aScreen>\[2], <aScreen>\[3], ;
            <aScreen>\[4], <aScreen>\[5])
#define GS_TOP    1
#define GS_LEFT   2
#define GS_BOTTOM 3
#define GS_RIGHT  4
#define GS_SCREEN 5

// Make any variable an array (if it isn't already).
#xtranslate MakeArray( <xVar> ) => ;
            If(!ValType(<xVar>) == "A", <xVar>:={<xVar>}, <xVar>)


#endif
